## crawl 0.9.0

=== debian/changelog ===
crawl (2:0.9.0-1) unstable; urgency=low

  * New upstream release.
  * Drop debian/NEWS warning about save compatibility -- not only 0.8 saves
    can be loaded in 0.9, but incompatible saves produce user-friendly
    messages as well.
  * Fix handling of {build,binary}-{arch,indep}.
  * Support cross-compiling.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 12 Aug 2011 18:47:47 +0200

## crawl 0.9.1

=== source/rltiles/Makefile ===
uname_S := $(shell uname -s)

ifneq (,$(findstring MINGW,$(uname_S)))
LDFLAGS += -lmingw32
endif

# Note: since generation of tiles is done on the host, we don't care about
# cross-compilation here.
#
# Also, cross-compilation with no system libraries for host rather than target
# is not supported.  If host=target, contribs are enough.

ifndef CONTRIB_SDL
SDL_CFLAGS := $(shell sdl-config --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include/SDL")
SDL_LDFLAGS := $(shell sdl-config --libs 2> /dev/null && echo "-lSDL_image" || echo "../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a")
else
SDL_CFLAGS := -I../contrib/install/$(ARCH)/include/SDL
SDL_LDFLAGS := ../contrib/install/$(ARCH)/lib/libSDL.a ../contrib/install/$(ARCH)/lib/libSDLmain.a ../contrib/install/$(ARCH)/lib/libSDL_image.a
endif

ifndef NO_PKGCONFIG
PNG_INCLUDE := $(shell pkg-config libpng --cflags 2> /dev/null || echo "-I../contrib/install/$(ARCH)/include")
PNG_LIB := $(shell pkg-config libpng --libs 2> /dev/null || echo "../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a")
else
PNG_INCLUDE := -I../contrib/install/$(ARCH)/include
PNG_LIB := ../contrib/install/$(ARCH)/lib/libpng.a ../contrib/install/$(ARCH)/lib/libz.a
endif

CFLAGS := -O2 $(SDL_CFLAGS) $(PNG_INCLUDE)
LDFLAGS += $(SDL_LDFLAGS) $(PNG_LIB)

ifneq (,$(findstring MINGW,$(uname_S)))
LDFLAGS += -lgdi32 -lwinmm
endif
ifeq ($(uname_S),Darwin)
LDFLAGS += -framework AppKit -framework AudioUnit -framework Carbon -framework IOKit -framework OpenGL
endif
ifeq ($(uname_S),Linux)
LDFLAGS += -ldl -lpthread
endif

# Attempt to use a full compiler name, to make
# distcc builds work nicely.
LMACH := $(shell gcc -dumpmachine)-
ifeq ($(LMACH),-)
LMACH :=
endif
ifeq ($(shell which $(LMACH)gcc > /dev/null 2> /dev/null && echo "Yes"),)
LMACH :=
endif
CXX = $(LMACH)g++

DELETE = rm -f

TOOLDIR := tool
TILEGEN := $(TOOLDIR)/tilegen.elf

INPUTS := main dngn floor wall feat player gui icons
INPUTFILES := $(INPUTS:%=dc-%.txt)
HEADERS := $(INPUTS:%=tiledef-%.h)
HTML := $(INPUTS:%=tile-%.html)
SOURCE := $(INPUTS:%=tiledef-%.cc)
IMAGES := $(INPUTS:%=%.png)
JAVASCRIPT := $(INPUTS:%=tileinfo-%.js)

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_CXX      = @echo '   ' CXX $@;
        QUIET_GEN      = @echo '   ' GEN $(lastword $(subst -, ,$*));
        QUIET_LINK     = @echo '   ' LINK $@;
        export V
endif
endif

BASE_OBJECTS := tile_colour.o tile.o tile_page.o tile_list_processor.o main.o
OBJECTS := $(BASE_OBJECTS:%=$(TOOLDIR)/%)

all: $(TILEGEN) $(HEADERS) $(SOURCE) $(IMAGES) $(JAVASCRIPT)

%.png tiledef-%.h tiledef-%.cc tileinfo-%.js: dc-%.txt | $(TILEGEN)
	$(QUIET_GEN)$(TILEGEN) $<

DEPS := $(shell ls $(OBJECTS:%.o=%.d) $(INPUTS:%=%.d) 2> /dev/null)

ifneq ($(DEPS),)
-include $(DEPS)
endif

clean:
	$(DELETE) $(HEADERS) $(OBJECTS) $(TILEGEN) $(SOURCE) $(IMAGES) $(HTML) $(DEPS) $(JAVASCRIPT)

distclean: clean

%.o: %.cc
	$(QUIET_CXX)$(CXX) $(CFLAGS) -Wp,-MD,$*.d,-MT,$@ -c $< -o $@

$(TILEGEN): $(OBJECTS)
	$(QUIET_LINK)$(CXX) $(OBJECTS) -o $@ $(LDFLAGS)

.PHONY: all clean distclean

=== debian/changelog ===
crawl (2:0.9.1-1) unstable; urgency=low

  * New upstream bugfix release.

 -- Adam Borowski <kilobyte@angband.pl>  Mon, 05 Sep 2011 13:14:17 +0200

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

CFOPTIMIZE = -O2
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CFOPTIMIZE = -O0
endif
ifneq (,$(shell gcc --version|grep 'gcc (.*) 4\.4\.'))
  ifeq ($(DEB_HOST_ARCH),powerpc)
	# g++-4.4 has an ICE there.
	CFOPTIMIZE = -O0
  endif
endif

tree-stamp:
	dh_testdir
	mkdir build-console
	cp -ldpR docs settings source build-console/
	rm -rf build-console/rltiles/*
	mkdir build-tiles
	cp -ldpR docs settings source build-tiles/
	touch tree-stamp

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CROSS=CROSSHOST=$(DEB_HOST_GNU_TYPE)
endif

# The makefile is unorthodox, requiring all options to be specified on every invocation.
ARGS_CONSOLE = prefix=/usr CFOPTIMIZE=$(CFOPTIMIZE) WIZARD=y $(CROSS)
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf

build-arch build-indep: build-stamp
build-stamp: tree-stamp
	dh_testdir

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE)
	cd build-tiles/source && $(MAKE) $(ARGS_TILES)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp tree-stamp
	rm -rf build-console build-tiles

	git clean -dfX || true

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE) install DESTDIR=../../debian/crawl-common
	#cd debian/crawl-common/usr/share && mkdir -p doc/crawl-common && \
	#	mv crawl/docs/* doc/crawl-common && \
	#	mv doc/crawl-common/crawl_manual.txt crawl/docs
	rm -rf debian/crawl-common/usr/share/crawl/docs/license
	mkdir -p debian/crawl/usr/
	mv debian/crawl-common/usr/games debian/crawl/usr/games
	cd build-tiles/source && $(MAKE) $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
	rm -rf debian/crawl-tiles/var
	cd debian/crawl-tiles/usr/share/crawl/ && rm -rf docs settings
	cd debian/crawl-tiles/usr/share/crawl/dat && rm -rf des dlua database descript lua
	
	mkdir -p debian/crawl/usr/share/man/man6
	cp docs/crawl.6 debian/crawl/usr/share/man/man6/
	mkdir -p debian/crawl-tiles/usr/share/man/man6
	cp docs/crawl.6 debian/crawl-tiles/usr/share/man/man6/crawl-tiles.6
	mkdir -p debian/crawl-common/usr/share/doc/crawl-common/examples
	cp settings/init.txt debian/crawl-common/usr/share/doc/crawl-common/examples/crawlrc
	ln -sf /usr/share/crawl/docs/*.txt debian/crawl-common/usr/share/doc/crawl-common/

	mkdir -p debian/crawl/usr/share/doc
	ln -sf crawl-common debian/crawl/usr/share/doc/crawl
	mkdir -p debian/crawl-tiles/usr/share/doc
	ln -sf crawl-common debian/crawl-tiles/usr/share/doc/crawl-tiles
	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications
	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps
	dh_link -pcrawl-tiles usr/share/games/crawl/dat/tiles/stone_soup_icon-32x32.png \
		usr/share/icons/hicolor/32x32/apps/crawl.png

# Build architecture-independent files here.
binary-indep: install
	dh_testdir
	dh_testroot
	dh_installdocs -pcrawl-common -Xcrawl_manual.txt -Xaptitudes.txt -Xquickstart.txt -Xmacros_guide.txt -Xoptions_guide.txt -Xtiles_help.txt
	dh_installchangelogs -pcrawl-common docs/changelog.txt
	dh_link -i
	dh_compress -i -Xaptitudes.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installmenu -a
	dh_link -a
	dh_compress -a -Xaptitudes.txt
	dh_strip -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

build: build-indep build-arch
binary: binary-indep binary-arch
.PHONY: build-indep build-arch build clean binary-indep binary-arch binary install

## crawl 0.9.1-maemo1

=== source/contrib/pcre/Makefile ===
# -*- Makefile -*- for PCRE (Win32, MinGW)

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_CC       = @echo '   ' CC $@;
        QUIET_AR       = @echo '   ' AR $@;
        QUIET_RANLIB   = @echo '   ' RANLIB $@;
        QUIET_INSTALL  = @echo '   ' INSTALL $<;
        export V
endif
endif

prefix ?= /usr/local
libdir := $(prefix)/lib
includedir := $(prefix)/include
mandir := $(prefix)/share/man
man3dir := $(mandir)/man3

MAN3 := \
	doc/pcre.3 \
	doc/pcre_compile.3 \
	doc/pcre_compile2.3 \
	doc/pcre_config.3 \
	doc/pcre_copy_named_substring.3 \
	doc/pcre_copy_substring.3 \
	doc/pcre_dfa_exec.3 \
	doc/pcre_exec.3 \
	doc/pcre_free_substring.3 \
	doc/pcre_free_substring_list.3 \
	doc/pcre_fullinfo.3 \
	doc/pcre_get_named_substring.3 \
	doc/pcre_get_stringnumber.3 \
	doc/pcre_get_stringtable_entries.3 \
	doc/pcre_get_substring.3 \
	doc/pcre_get_substring_list.3 \
	doc/pcre_info.3 \
	doc/pcre_maketables.3 \
	doc/pcre_refcount.3 \
	doc/pcre_study.3 \
	doc/pcre_version.3 \
	doc/pcreapi.3 \
	doc/pcrebuild.3 \
	doc/pcrecallout.3 \
	doc/pcrecompat.3 \
	doc/pcrematching.3 \
	doc/pcrepartial.3 \
	doc/pcrepattern.3 \
	doc/pcreperform.3 \
	doc/pcreposix.3 \
	doc/pcreprecompile.3 \
	doc/pcresample.3 \
	doc/pcrestack.3 \
	doc/pcresyntax.3

MAN3_INST := $(patsubst doc/%,$(man3dir)/%,$(MAN3))

OBJECTS := \
	pcre_chartables.o \
	pcre_compile.o \
	pcre_config.o \
	pcre_dfa_exec.o \
	pcre_exec.o \
	pcre_fullinfo.o \
	pcre_get.o \
	pcre_globals.o \
	pcre_info.o \
	pcre_maketables.o \
	pcre_newline.o \
	pcre_ord2utf8.o \
	pcre_refcount.o \
	pcre_study.o \
	pcre_tables.o \
	pcre_try_flipped.o \
	pcre_ucd.o \
	pcre_valid_utf8.o \
	pcre_version.o \
	pcre_xclass.o

CC ?= gcc
AR ?= ar
RANLIB ?= ranlib
RM ?= rm -f

CFLAGS += -I. -DHAVE_CONFIG_H
LDFLAGS :=

LIBNAME := libpcre.a

all: $(LIBNAME)

distclean: clean

clean:
	$(RM) $(LIBNAME) $(OBJECTS) .cflags

$(LIBNAME) : $(OBJECTS)
	@$(RM) $@
	$(QUIET_AR)$(AR) rcu $@ $?
	$(QUIET_RANLIB)$(RANLIB) $@

%.o: %.c .cflags
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ -c $<

$(includedir)/%.h: %.h
	-@if [ ! -d $(includedir)  ]; then mkdir -p $(includedir); fi
	$(QUIET_INSTALL)cp $< $@
	@chmod 0644 $@

$(man3dir)/%.3: doc/%.3
	-@if [ ! -d $(man3dir)  ]; then mkdir -p $(man3dir); fi
	$(QUIET_INSTALL)cp $< $@
	@chmod 0644 $@

$(libdir)/%.a: %.a
	-@if [ ! -d $(libdir)  ]; then mkdir -p $(libdir); fi
	$(QUIET_INSTALL)cp $< $@
	@chmod 0755 $@

install: $(libdir)/$(LIBNAME) $(MAN3_INST)  $(includedir)/pcre.h

TRACK_CFLAGS = $(subst ','\'',$(CC) $(CFLAGS))

.cflags: .force-cflags
	@FLAGS='$(TRACK_CFLAGS)'; \
    if test x"$$FLAGS" != x"`cat .cflags 2>/dev/null`" ; then \
        echo "    * rebuilding pcre: new build flags or prefix"; \
        echo "$$FLAGS" > .cflags; \
    fi

.PHONY: .force-cflags

=== source/contrib/sdl-image/Makefile ===
# -*- Makefile -*- for sdl-image

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_CC       = @echo '   ' CC $@;
        QUIET_AR       = @echo '   ' AR $@;
        QUIET_RANLIB   = @echo '   ' RANLIB $@;
        QUIET_INSTALL  = @echo '   ' INSTALL $<;
        export V
endif
endif

LIB    = libSDL_image.a
AR    ?= ar
CC    ?= gcc
RANLIB?= ranlib
RM    ?= rm -f

prefix ?= /usr/local
libdir := $(prefix)/lib
includedir := $(prefix)/include/SDL

HEADERS = SDL_image.h
SOURCES = IMG.c IMG_bmp.c IMG_gif.c IMG_ImageIO.c IMG_jpg.c IMG_lbm.c \
    IMG_pcx.c IMG_png.c IMG_pnm.c IMG_tga.c IMG_tif.c IMG_xcf.c \
	IMG_xpm.c IMG_xv.c

HEADERS_INST := $(patsubst %,$(includedir)/%,$(HEADERS))
OBJECTS := $(patsubst %.c,%.o,$(SOURCES))

CFLAGS ?= -O2
CFLAGS += -I$(prefix)/include -I$(includedir) -DLOAD_PNG -DLOAD_BMP

.PHONY: install

all: $(LIB)

$(includedir)/%.h: %.h
	-@if [ ! -d $(includedir)  ]; then mkdir -p $(includedir); fi
	$(QUIET_INSTALL)cp $< $@
	@chmod 0644 $@

$(libdir)/%.a: %.a
	-@if [ ! -d $(libdir)  ]; then mkdir -p $(libdir); fi
	$(QUIET_INSTALL)cp $< $@
	@chmod 0644 $@

install: $(HEADERS_INST) $(libdir)/$(LIB)

clean:
	$(RM) $(OBJECTS) $(LIB) .cflags

distclean: clean

$(LIB): $(OBJECTS)
	@$(RM) $@
	$(QUIET_AR)$(AR) rcu $@ $^
	$(QUIET_RANLIB)$(RANLIB) $@

%.o: %.c .cflags
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ -c $<

TRACK_CFLAGS = $(subst ','\'',$(CC) $(CFLAGS))

.cflags: .force-cflags
	@FLAGS='$(TRACK_CFLAGS)'; \
    if test x"$$FLAGS" != x"`cat .cflags 2>/dev/null`" ; then \
        echo "    * rebuilding sdl-image: new build flags or prefix"; \
        echo "$$FLAGS" > .cflags; \
    fi

.PHONY: .force-cflags

=== source/contrib/sqlite/Makefile ===
# -*- Makefile -*- for stripped down SQLite 3 static lib.

ifneq ($(findstring $(MAKEFLAGS),s),s)
ifndef V
        QUIET_CC       = @echo '   ' CC $@;
        QUIET_AR       = @echo '   ' AR $@;
        QUIET_RANLIB   = @echo '   ' RANLIB $@;
        QUIET_INSTALL  = @echo '   ' INSTALL $<;
        export V
endif
endif

LIBSQL = libsqlite3.a
AR    ?= ar
CC    ?= gcc
RANLIB?= ranlib
RM    ?= rm -f

prefix ?= /usr/local
libdir := $(prefix)/lib
includedir := $(prefix)/include

# Omit SQLite features we don't need.
CFLAGS ?= -O2
CFLAGS +=-DSQLITE_OMIT_AUTHORIZATION \
		 -DSQLITE_OMIT_AUTOVACUUM \
		 -DSQLITE_OMIT_COMPLETE \
		 -DSQLITE_OMIT_BLOB_LITERAL \
		 -DSQLITE_OMIT_COMPOUND_SELECT \
		 -DSQLITE_OMIT_CONFLICT_CLAUSE \
		 -DSQLITE_OMIT_DATETIME_FUNCS \
		 -DSQLITE_OMIT_EXPLAIN \
		 -DSQLITE_OMIT_INTEGRITY_CHECK \
		 -DSQLITE_OMIT_PAGER_PRAGMAS \
		 -DSQLITE_OMIT_PROGRESS_CALLBACK \
		 -DSQLITE_OMIT_SCHEMA_PRAGMAS \
		 -DSQLITE_OMIT_SCHEMA_VERSION_PRAGMAS \
		 -DSQLITE_OMIT_TCL_VARIABLE \
		 -DSQLITE_OMIT_LOAD_EXTENSION \
		 -DSQLITE_PREFER_PROXY_LOCKING=0 \
		 -DSQLITE_THREADSAFE=0 \
		 -DSQLITE_ENABLE_LOCKING_STYLE=0 \
		 -DSQLITE_DEBUG=0 \
		 -w

.PHONY: install

all: $(LIBSQL)

$(includedir)/%.h: %.h
	-@if [ ! -d $(includedir)  ]; then mkdir -p $(includedir); fi
	$(QUIET_INSTALL)cp $< $@
	@chmod 0644 $@

$(libdir)/%.a: %.a
	-@if [ ! -d $(libdir)  ]; then mkdir -p $(libdir); fi
	$(QUIET_INSTALL)cp $< $@
	@chmod 0644 $@

install: $(includedir)/sqlite3.h $(libdir)/libsqlite3.a

clean:
	$(RM) sqlite3.o $(LIBSQL) .cflags

distclean: clean

$(LIBSQL): sqlite3.o
	@$(RM) $@
	$(QUIET_AR)$(AR) rcu $@ $^
	$(QUIET_RANLIB)$(RANLIB) $@

%.o: %.c .cflags
	$(QUIET_CC)$(CC) $(CFLAGS) -o $@ -c $<

TRACK_CFLAGS = $(subst ','\'',$(CC) $(CFLAGS))

.cflags: .force-cflags
	@FLAGS='$(TRACK_CFLAGS)'; \
    if test x"$$FLAGS" != x"`cat .cflags 2>/dev/null`" ; then \
        echo "    * rebuilding sqlite: new build flags or prefix"; \
        echo "$$FLAGS" > .cflags; \
    fi

.PHONY: .force-cflags

=== debian/changelog ===
crawl (2:0.9.1-maemo1) unstable; urgency=low

  * Fremantle packaging
  * Work around a g++-4.2 bug 
  * Use keycode '-1010' for enter (N900)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Wed, 31 Aug 2011 15:55:30 +0200

=== debian/control ===
Source: crawl
Section: games
Priority: optional
Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com>
Standards-Version: 3.9.1
Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
	libfreetype6-dev, libpng12-dev, libsdl-gles1.2-dev, libgles1-sgx-img-dev [arm armel], opengles-sgx-img-common-dev [arm armel], libgl1-mesa-dev [i386], libglu1-mesa-dev [i386]
Homepage: http://crawl.develz.org/
XSBC-Bugtracker: https://crawl.develz.org/mantis/

Package: crawl-common
Architecture: all
Depends: ${shlibs:Depends}, ${misc:Depends}
Recommends: crawl | crawl-tiles
Description: Dungeon Crawl, a text-based roguelike game (data files)
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 These are the data and support files.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
Description: Dungeon Crawl, a text-based roguelike game
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the console version, for tiles, use crawl-tiles instead.
 .
 This is the Stone Soup version of Dungeon Crawl.

Package: crawl-tiles
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), ttf-dejavu
Description: Dungeon Crawl, a roguelike game, tiles version
 Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
 Moria. Your objective is to travel deep into a subterranean cave complex and
 retrieve the Orb of Zot, which is guarded by many horrible and hideous
 creatures.
 .
 This is the graphical (tiles) version.
 .
 This is the Stone Soup version of Dungeon Crawl.

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

CFOPTIMIZE = -O2
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CFOPTIMIZE = -O0
endif
ifeq ($(DEB_HOST_ARCH),powerpc)
	# g++-4.4 has an ICE there.
	CFOPTIMIZE = -O0
endif

tree-stamp:
	dh_testdir
	rm -rf build-console
	mkdir -p build-console/source/rltiles
	tar cf - --exclude=contrib --exclude=rltiles docs settings source | tar xf - -C build-console
	cp -p source/rltiles/dc-player.txt build-console/source/rltiles/
	rm -rf build-tiles
	mkdir -p build-tiles
	tar cf - --exclude=contrib docs settings source |tar xf - -C build-tiles
	touch tree-stamp

# The makefile is unorthodox, requiring all options to be specified on every invocation.
ARGS_CONSOLE = prefix=/opt/crawl SAVEDIR='/home/user/.crawl' SHAREDDIR=/opt/crawl CFOPTIMIZE=$(CFOPTIMIZE)

ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GLES=y GAME=crawl-tiles \
	PROPORTIONAL_FONT=/opt/crawl/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
	MONOSPACED_FONT=/opt/crawl/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
else
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
	PROPORTIONAL_FONT=/opt/crawl/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
	MONOSPACED_FONT=/opt/crawl/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
endif

build: build-stamp
build-stamp: tree-stamp
	dh_testdir

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE)
	cd build-tiles/source && $(MAKE) $(ARGS_TILES)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp tree-stamp
	rm -rf build-console build-tiles


	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE) install DESTDIR=../../debian/crawl-common
	cd debian/crawl-common/opt/crawl && mkdir -p doc/crawl-common && \
		mv data/docs/* doc/crawl-common && \
		mv doc/crawl-common/crawl_manual.txt data/docs
	rm -rf debian/crawl-common/opt/crawl/doc/crawl-common/license
	mkdir -p debian/crawl/opt/crawl
	mv debian/crawl-common/opt/crawl debian/crawl/opt/crawl
	cd build-tiles/source && $(MAKE) $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
	#rm -rf debian/crawl-tiles/var
	#cd debian/crawl-tiles/opt/crawl/crawl/ && rm -rf docs settings
	#cd debian/crawl-tiles/opt/crawl/crawl/dat && rm -rf des clua database descript lua
	
	mkdir -p debian/crawl/opt/crawl/man/man6
	cp docs/crawl.6 debian/crawl/opt/crawl/man/man6/
	mkdir -p debian/crawl-tiles/opt/crawl/man/man6
	cp docs/crawl.6 debian/crawl-tiles/opt/crawl/man/man6/crawl-tiles.6
	mkdir -p debian/crawl-common/opt/crawl/lintian/overrides
	cp debian/crawl-common.overrides debian/crawl-common/opt/crawl/lintian/overrides/crawl-common
	mkdir -p debian/crawl-common/opt/crawl/doc/crawl-common/examples
	cp settings/init.txt debian/crawl-common/opt/crawl/doc/crawl-common/examples/crawlrc
	ln -sf /opt/crawl/crawl-common/docs/crawl_manual.txt debian/crawl-common/opt/crawl/doc/crawl-common/

	mkdir -p debian/crawl/opt/crawl/doc
	ln -sf crawl-common debian/crawl/opt/crawl/doc/crawl
	mkdir -p debian/crawl-tiles/opt/crawl/doc
	ln -sf crawl-common debian/crawl-tiles/opt/crawl/doc/crawl-tiles
	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications/hildon
	dh_install -pcrawl-tiles debian/crawl.png usr/share/pixmaps/
	dh_link -pcrawl-tiles opt/crawl/dat/tiles/stone_soup_icon-32x32.png \
		usr/share/pixmaps/crawl.png

# Build architecture-independent files here.
binary-indep:
# We have nothing to do by default.

# Build architecture-dependent files here.
binary-arch: build install
	dh_testdir
	dh_testroot
	dh_installdocs -pcrawl-common
	dh_installchangelogs -pcrawl-common docs/changelog.txt
	dh_installmenu
	dh_link
	dh_strip
	dh_compress
	dh_fixperms
	chgrp games debian/crawl/opt/crawl/crawl
	chmod g+s debian/crawl/opt/crawl/crawl
	chgrp games debian/crawl-tiles/opt/crawl/bin/crawl-tiles
	chmod g+s debian/crawl-tiles/opt/crawl/bin/crawl-tiles
	chgrp -R games debian/crawl-common/opt/crawl
	chmod -R g+ws debian/crawl-common/opt/crawl
	dh_installdeb
	dh_shlibdeps
	dh_gencontrol
	dh_md5sums
	dh_builddeb

binary: binary-indep binary-arch
.PHONY: build clean binary-indep binary-arch binary install

## crawl 0.9.1-maemo2

=== debian/changelog ===
crawl (2:0.9.1-maemo2) unstable; urgency=low
  
  * Not OPTIFIED
  * Work around a g++-4.2 bug
  * Use keycode '-1010' for enter (N900)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu,  1 Sep 2011 09:27:30 +0200

crawl (2:0.9.0-1~1) unstable; urgency=low

  * New upstream release.
  * Drop debian/NEWS warning about save compatibility -- not only 0.8 saves
    can be loaded in 0.9, but incompatible saves produce user-friendly
    messages as well.
  * Fix handling of {build,binary}-{arch,indep}.
  * Support cross-compiling.

 -- Adam Borowski <kilobyte@angband.pl>  Fri, 12 Aug 2011 18:47:47 +0200

=== debian/control ===
--- 
+++ 
@@ -2,10 +2,11 @@
 Section: games
 Priority: optional
 Maintainer: Aapo Rantalainen <aapo.rantalainen@gmail.com>
-Standards-Version: 3.9.1
+Standards-Version: 3.9.2
 Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
-	libfreetype6-dev, libpng12-dev, libsdl-gles1.2-dev, libgles1-sgx-img-dev [arm armel], opengles-sgx-img-common-dev [arm armel], libgl1-mesa-dev [i386], libglu1-mesa-dev [i386]
+	libfreetype6-dev,  libpng12-dev, libsdl-gles1.2-dev,
+	libgles1-sgx-img-dev [arm armel], opengles-sgx-img-common-dev [arm armel], libgl1-mesa-dev [i386], libglu1-mesa-dev [i386]
 Homepage: http://crawl.develz.org/
 XSBC-Bugtracker: https://crawl.develz.org/mantis/

## crawl 0.9.1-maemo3

=== debian/changelog ===
crawl (2:0.9.1-maemo3) unstable; urgency=low
  
  * Not OPTIFIED
  * Dependencies fixed
  * Newer code from git

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu,  1 Sep 2011 11:43:30 +0200

=== debian/rules ===
#!/usr/bin/make -f

ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
	MAKEFLAGS += -j$(NUMJOBS)
endif

CFOPTIMIZE = -O2
ifneq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
	CFOPTIMIZE = -O0
endif
ifneq (,$(shell gcc --version|grep 'gcc (.*) 4\.4\.'))
  ifeq ($(DEB_HOST_ARCH),powerpc)
	# g++-4.4 has an ICE there.
	CFOPTIMIZE = -O0
  endif
endif

tree-stamp:
	dh_testdir
	mkdir build-console
	cp -ldpR docs settings source build-console/
	rm -rf build-console/rltiles/*
	mkdir build-tiles
	cp -ldpR docs settings source build-tiles/
	touch tree-stamp

DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_BUILD_GNU_TYPE),$(DEB_HOST_GNU_TYPE))
	CROSS=CROSSHOST=$(DEB_HOST_GNU_TYPE)
endif

# The makefile is unorthodox, requiring all options to be specified on every invocation.
ARGS_CONSOLE = prefix=/usr CFOPTIMIZE=$(CFOPTIMIZE) WIZARD=y $(CROSS)
ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GLES=y GAME=crawl-tiles \
	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
else
ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
    PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
    MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
endif

build-arch build-indep: build-stamp
build-stamp: tree-stamp
	dh_testdir

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE)
	cd build-tiles/source && $(MAKE) $(ARGS_TILES)

	touch build-stamp

clean:
	dh_testdir
	dh_testroot

	rm -f build-stamp tree-stamp
	rm -rf build-console build-tiles

	git clean -dfX || true

	dh_clean

install: build
	dh_testdir
	dh_testroot
	dh_prep
	dh_installdirs

	cd build-console/source && $(MAKE) $(ARGS_CONSOLE) install DESTDIR=../../debian/crawl-common
	#cd debian/crawl-common/usr/share && mkdir -p doc/crawl-common && \
	#	mv crawl/docs/* doc/crawl-common && \
	#	mv doc/crawl-common/crawl_manual.txt crawl/docs
	rm -rf debian/crawl-common/usr/share/crawl/docs/license
	mkdir -p debian/crawl/usr/
	mv debian/crawl-common/usr/games debian/crawl/usr/games
	cd build-tiles/source && $(MAKE) $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
	rm -rf debian/crawl-tiles/var
	cd debian/crawl-tiles/usr/share/crawl/ && rm -rf docs settings
	cd debian/crawl-tiles/usr/share/crawl/dat && rm -rf des dlua database descript lua
	
	mkdir -p debian/crawl/usr/share/man/man6
	cp docs/crawl.6 debian/crawl/usr/share/man/man6/
	mkdir -p debian/crawl-tiles/usr/share/man/man6
	cp docs/crawl.6 debian/crawl-tiles/usr/share/man/man6/crawl-tiles.6
	mkdir -p debian/crawl-common/usr/share/doc/crawl-common/examples
	cp settings/init.txt debian/crawl-common/usr/share/doc/crawl-common/examples/crawlrc
	ln -sf /usr/share/crawl/docs/*.txt debian/crawl-common/usr/share/doc/crawl-common/

	mkdir -p debian/crawl/usr/share/doc
	ln -sf crawl-common debian/crawl/usr/share/doc/crawl
	mkdir -p debian/crawl-tiles/usr/share/doc
	ln -sf crawl-common debian/crawl-tiles/usr/share/doc/crawl-tiles
	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications
	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps
	dh_link -pcrawl-tiles usr/share/games/crawl/dat/tiles/stone_soup_icon-32x32.png \
		usr/share/icons/hicolor/32x32/apps/crawl.png

# Build architecture-independent files here.
binary-indep: install
	dh_testdir
	dh_testroot
	dh_installdocs -pcrawl-common -Xcrawl_manual.txt -Xaptitudes.txt -Xquickstart.txt -Xmacros_guide.txt -Xoptions_guide.txt -Xtiles_help.txt
	dh_installchangelogs -pcrawl-common docs/changelog.txt
	dh_link -i
	dh_compress -i -Xaptitudes.txt
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i

# Build architecture-dependent files here.
binary-arch: install
	dh_testdir
	dh_testroot
	dh_installmenu -a
	dh_link -a
	dh_compress -a -Xaptitudes.txt
	dh_strip -a
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

build: build-indep build-arch
binary: binary-indep binary-arch
.PHONY: build-indep build-arch build clean binary-indep binary-arch binary install

## crawl 0.9.1-maemo4

=== debian/changelog ===
crawl (2:0.9.1-maemo4) unstable; urgency=low
  
  * prefix=/opt/crawl
  * build tiles with debug

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu,  1 Sep 2011 13:16:30 +0200

=== debian/control ===
--- 
+++ 
@@ -39,7 +39,7 @@
 
 Package: crawl-tiles
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version}), ttf-dejavu
+Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
 Description: Dungeon Crawl, a roguelike game, tiles version
  Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
  Moria. Your objective is to travel deep into a subterranean cave complex and

=== debian/rules ===
--- 
+++ 
@@ -31,8 +31,10 @@
 	CROSS=CROSSHOST=$(DEB_HOST_GNU_TYPE)
 endif
 
+PREFIX=/opt/crawl
+
 # The makefile is unorthodox, requiring all options to be specified on every invocation.
-ARGS_CONSOLE = prefix=/usr CFOPTIMIZE=$(CFOPTIMIZE) WIZARD=y $(CROSS)
+ARGS_CONSOLE = prefix=$(PREFIX) CFOPTIMIZE=$(CFOPTIMIZE) WIZARD=y $(CROSS)
 ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
 ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GLES=y GAME=crawl-tiles \
 	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
@@ -48,7 +50,7 @@
 	dh_testdir
 
 	cd build-console/source && $(MAKE) $(ARGS_CONSOLE)
-	cd build-tiles/source && $(MAKE) $(ARGS_TILES)
+	cd build-tiles/source && $(MAKE) debug $(ARGS_TILES)
 
 	touch build-stamp
 
@@ -73,30 +75,30 @@
 	#cd debian/crawl-common/usr/share && mkdir -p doc/crawl-common && \
 	#	mv crawl/docs/* doc/crawl-common && \
 	#	mv doc/crawl-common/crawl_manual.txt crawl/docs
-	rm -rf debian/crawl-common/usr/share/crawl/docs/license
-	mkdir -p debian/crawl/usr/
-	mv debian/crawl-common/usr/games debian/crawl/usr/games
-	cd build-tiles/source && $(MAKE) $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
+	rm -rf debian/crawl-common/$(PREFIX)/share/crawl/docs/license
+	mkdir -p debian/crawl/$(PREFIX)/
+	mv debian/crawl-common/$(PREFIX)/* debian/crawl/$(PREFIX)
+	cd build-tiles/source && $(MAKE) debug $(ARGS_TILES) install DESTDIR=../../debian/crawl-tiles
 	rm -rf debian/crawl-tiles/var
-	cd debian/crawl-tiles/usr/share/crawl/ && rm -rf docs settings
-	cd debian/crawl-tiles/usr/share/crawl/dat && rm -rf des dlua database descript lua
+	cd debian/crawl-tiles/$(PREFIX)/data && rm -rf docs settings
+	cd debian/crawl-tiles/$(PREFIX)/data/dat && rm -rf des dlua database descript lua
 	
-	mkdir -p debian/crawl/usr/share/man/man6
-	cp docs/crawl.6 debian/crawl/usr/share/man/man6/
-	mkdir -p debian/crawl-tiles/usr/share/man/man6
-	cp docs/crawl.6 debian/crawl-tiles/usr/share/man/man6/crawl-tiles.6
-	mkdir -p debian/crawl-common/usr/share/doc/crawl-common/examples
-	cp settings/init.txt debian/crawl-common/usr/share/doc/crawl-common/examples/crawlrc
-	ln -sf /usr/share/crawl/docs/*.txt debian/crawl-common/usr/share/doc/crawl-common/
+	mkdir -p debian/crawl$(PREFIX)/share/man/man6
+	cp docs/crawl.6 debian/crawl$(PREFIX)/share/man/man6/
+	mkdir -p debian/crawl-tiles$(PREFIX)/share/man/man6
+	cp docs/crawl.6 debian/crawl-tiles$(PREFIX)/share/man/man6/crawl-tiles.6
+	mkdir -p debian/crawl-common$(PREFIX)/share/doc/crawl-common/examples
+	cp settings/init.txt debian/crawl-common$(PREFIX)/share/doc/crawl-common/examples/crawlrc
+	ln -sf $(PREFIX)/share/crawl/docs/*.txt debian/crawl-common/$(PREFIX)/share/doc/crawl-common/
 
-	mkdir -p debian/crawl/usr/share/doc
-	ln -sf crawl-common debian/crawl/usr/share/doc/crawl
-	mkdir -p debian/crawl-tiles/usr/share/doc
-	ln -sf crawl-common debian/crawl-tiles/usr/share/doc/crawl-tiles
-	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications
-	dh_install -pcrawl-tiles debian/crawl.png usr/share/icons/hicolor/48x48/apps
-	dh_link -pcrawl-tiles usr/share/games/crawl/dat/tiles/stone_soup_icon-32x32.png \
-		usr/share/icons/hicolor/32x32/apps/crawl.png
+	mkdir -p debian/crawl/$(PREFIX)/share/doc
+	ln -sf crawl-common debian/crawl/$(PREFIX)/share/doc/crawl
+	mkdir -p debian/crawl-tiles/$(PREFIX)/share/doc
+	ln -sf crawl-common debian/crawl-tiles/$(PREFIX)/share/doc/crawl-tiles
+	dh_install -pcrawl-tiles debian/crawl-tiles.desktop usr/share/applications/hildob
+	dh_install -pcrawl-tiles debian/crawl.png usr/share/pixmaps/ 
+	#dh_link -pcrawl-tiles $(PREFIX)/share/games/crawl/dat/tiles/stone_soup_icon-32x32.png \
+	#	usr/share/icons/hicolor/32x32/apps/crawl.png
 
 # Build architecture-independent files here.
 binary-indep: install

## crawl 0.9.1-maemo6

=== source/contrib/luajit/src/Makefile ===
##############################################################################
# LuaJIT Makefile. Requires GNU Make.
#
# Suitable for POSIX platforms (Linux, *BSD, OSX etc.).
# Also works with MinGW and Cygwin on Windows.
# Please check msvcbuild.bat for building with MSVC on Windows.
#
# Copyright (C) 2005-2010 Mike Pall. See Copyright Notice in luajit.h
##############################################################################

MAJVER=  2
MINVER=  0
RELVER=  0
ABIVER=  5.1
NODOTABIVER= 51

##############################################################################
# Compiler options: change them as needed. This mainly affects the speed of
# the JIT compiler itself, not the speed of the JIT compiled code.
# Turn any of the optional settings on by removing the '#' in front of them.
# You need to 'make clean' and 'make' again, if you change any options.
#
# LuaJIT builds as a native 32 or 64 bit binary by default.
CC= gcc
#
# Use this if you want to force a 32 bit build on a 64 bit multilib OS.
#CC= gcc -m32
#
# Since the assembler part does NOT maintain a frame pointer, it's pointless
# to slow down the C part by not omitting it. Debugging, tracebacks and
# unwinding are not affected -- the assembler part has frame unwind
# information and GCC emits it where needed (x64) or with -g (see CCDEBUG).
CCOPT= -O2 -fomit-frame-pointer
# Use this if you want to generate a smaller binary (but it's slower):
#CCOPT= -Os -fomit-frame-pointer
# Note: it's no longer recommended to use -O3 with GCC 4.x.
# The I-Cache bloat usually outweighs the benefits from aggressive inlining.
#
# It's recommended to compile at least for i686. By default the assembler part
# of the interpreter makes use of CMOV/FCOMI*/FUCOMI* instructions, anyway.
# For GCC 4.2 or higher and if you don't intend to distribute the
# binaries to a different machine you could also use: -march=native
CCOPT_X86= -march=i686
CCOPT_X64=
#
CCDEBUG=
# Uncomment the next line to generate debug information:
#CCDEBUG= -g
#
CCWARN= -Wall
# Uncomment the next line to enable more warnings:
#CCWARN+= -Wextra -Wdeclaration-after-statement -Wredundant-decls -Wshadow -Wpointer-arith
#
##############################################################################

##############################################################################
# Compile time definitions: change them as needed, but make sure you force
# a full recompile with "make clean", followed by "make".
# Note that most of these are NOT suitable for benchmarking or release mode!
XCFLAGS=
#
# Disable the use of CMOV and FCOMI*/FUCOMI* instructions in the interpreter.
# This is only necessary if you intend to run the code on REALLY ANCIENT CPUs
# (before Pentium Pro, or on the VIA C3). This generally slows down the
# interpreter. Don't bother if your OS wouldn't run on them, anyway.
#XCFLAGS+= -DLUAJIT_CPU_NOCMOV
#
# Use SSE2 instructions instead of x87 instructions in the x86 interpreter
# (always enabled for x64). A pure interpreter built with this flag won't
# run on older CPUs (before P4 or K8). There isn't much of a speed
# difference, so this is not enabled by default.
# The JIT compiler is not affected by this flag. It always uses runtime
# CPU feature detection before emitting code for SSE2 up to SSE4.1.
#XCFLAGS+= -DLUAJIT_CPU_SSE2
#
# Disable the JIT compiler, i.e. turn LuaJIT into a pure interpreter:
#XCFLAGS+= -DLUAJIT_DISABLE_JIT
#
# Use the system provided memory allocator (realloc) instead of the
# bundled memory allocator. This is slower, but sometimes helpful for
# debugging. It's helpful for Valgrind's memcheck tool, too. This option
# cannot be enabled on x64, since the built-in allocator is mandatory.
#XCFLAGS+= -DLUAJIT_USE_SYSMALLOC
#
# This define is required to run LuaJIT under Valgrind. The Valgrind
# header files must be installed. You should enable debug information, too.
#XCFLAGS+= -DLUAJIT_USE_VALGRIND
#
# This is the client for the GDB JIT API. GDB 7.0 or higher is required
# to make use of it. See lj_gdbjit.c for details. Enabling this causes
# a non-negligible overhead, even when not running under GDB.
#XCFLAGS+= -DLUAJIT_USE_GDBJIT
#
# Turn on assertions for the Lua/C API to debug problems with lua_* calls.
# This is rather slow -- use only while developing C libraries/embeddings.
#XCFLAGS+= -DLUA_USE_APICHECK
#
# Turn on assertions for the whole LuaJIT VM. This significantly slows down
# everything. Use only if you suspect a problem with LuaJIT itself.
#XCFLAGS+= -DLUA_USE_ASSERT
#
##############################################################################

##############################################################################
# Build mode: override the mode as needed. Default is mixed mode on POSIX.
# On Windows this is the same as dynamic mode.
#
# Mixed mode creates a static + dynamic library and a statically linked luajit.
BUILDMODE= mixed
#
# Static mode creates a static library and a statically linked luajit.
#BUILDMODE= static
#
# Dynamic mode creates a dynamic library and a dynamically linked luajit.
# Note: this executable will only run when the library is installed!
#BUILDMODE= dynamic
##############################################################################
# You probably don't need to change anything below this line.
##############################################################################

##############################################################################
# Flags and options for host and target.
##############################################################################

# You may also override the following variables at the make command line:
#   CC       HOST_CC       STATIC_CC       DYNAMIC_CC
#   CFLAGS   HOST_CFLAGS   TARGET_CFLAGS
#   LDFLAGS  HOST_LDFLAGS  TARGET_LDFLAGS  TARGET_SHLDFLAGS
#   LIBS     HOST_LIBS     TARGET_LIBS
#   CROSS    HOST_SYS      TARGET_SYS
#
# Cross-compilation example:
#   make CC="gcc -m32" CROSS=i586-mingw32msvc- TARGET_SYS=Windows

CCOPTIONS= $(CCDEBUG) $(CCOPT) $(CCWARN) $(XCFLAGS) $(CFLAGS)
LDOPTIONS= $(CCDEBUG) $(LDFLAGS)

TARGET_ARCH= $(patsubst %,-DLUAJIT_TARGET=LUAJIT_ARCH_%,$(TARGET))

HOST_CC= $(CC)
HOST_RM= rm -f
# NOTE: The LuaJIT distribution comes with pre-generated buildvm_*.h files.
# You DO NOT NEED an installed copy of (plain) Lua 5.1 to run DynASM unless
# you want to MODIFY the corresponding *.dasc file. You can also use LuaJIT
# itself (bootstrapped from a pre-generated file) to run DynASM of course.
HOST_LUA= lua

HOST_XCFLAGS=
HOST_XLDFLAGS=
HOST_XLIBS=
HOST_ACFLAGS= $(CCOPTIONS) $(HOST_XCFLAGS) $(TARGET_ARCH) $(HOST_CFLAGS)
HOST_ALDFLAGS= $(LDOPTIONS) $(HOST_XLDFLAGS) $(HOST_LDFLAGS)
HOST_ALIBS= $(HOST_XLIBS) $(LIBS) $(HOST_LIBS)

STATIC_CC = $(CROSS)$(CC)
DYNAMIC_CC = $(CROSS)$(CC) -fPIC
TARGET_CC= $(STATIC_CC)
TARGET_STCC= $(STATIC_CC)
TARGET_DYNCC= $(DYNAMIC_CC)
TARGET_LD= $(CROSS)$(CC)
TARGET_AR= $(CROSS)ar rcus
TARGET_STRIP= $(CROSS)strip

TARGET_SONAME= libluajit-$(ABIVER).so.$(MAJVER)
TARGET_DYLIBNAME= libluajit-$(NODOTABIVER).$(MAJVER).$(MINVER).$(RELVER).dylib
TARGET_DLLNAME= lua$(NODOTABIVER).dll
TARGET_XSHLDFLAGS= -shared -fPIC -Wl,-soname,$(TARGET_SONAME)
TARGET_DYNXLDOPTS=

TARGET_XCFLAGS= -D_FILE_OFFSET_BITS=64 -U_FORTIFY_SOURCE
TARGET_XLDFLAGS=
TARGET_XLIBS= -lm
TARGET_ACFLAGS= $(CCOPTIONS) $(TARGET_XCFLAGS) $(TARGET_ARCH) $(TARGET_CFLAGS)
TARGET_ALDFLAGS= $(LDOPTIONS) $(TARGET_XLDFLAGS) $(TARGET_LDFLAGS)
TARGET_ASHLDFLAGS= $(LDOPTIONS) $(TARGET_XSHLDFLAGS) $(TARGET_SHLDFLAGS)
TARGET_ALIBS= $(TARGET_XLIBS) $(LIBS) $(TARGET_LIBS)

ifneq (,$(findstring stack-protector,$(shell $(TARGET_CC) -dumpspecs)))
  TARGET_XCFLAGS+= -fno-stack-protector
endif

ifeq (,$(findstring __i386__,$(shell echo __i386__ | $(TARGET_CC) -P -E -)))
  TARGET_CCARCH= x86
  TARGET_XCFLAGS+= $(CCOPT_X86)
else
  TARGET_CCARCH= x64
  TARGET_XCFLAGS+= $(CCOPT_X64)
endif

ifneq (,$(PREFIX))
ifneq (/usr/local,$(PREFIX))
  TARGET_XCFLAGS+= -DLUA_XROOT=\"$(PREFIX)/\"
  ifneq (/usr,$(PREFIX))
    TARGET_DYNXLDOPTS= -Wl,-rpath,$(PREFIX)/lib
  endif
endif
endif

##############################################################################
# System detection.
##############################################################################

ifneq (,$(findstring Windows,$(OS)))
  HOST_SYS= Windows
else
  HOST_SYS:= $(shell uname -s)
  ifneq (,$(findstring CYGWIN,$(TARGET_SYS)))
    HOST_SYS= Windows
  endif
endif
ifeq (Windows,$(HOST_SYS))
  HOST_RM= del
endif

TARGET_SYS= $(HOST_SYS)
ifeq (Windows,$(TARGET_SYS))
  TARGET_STRIP+= --strip-unneeded
  TARGET_XSHLDFLAGS= -shared
  TARGET_DYNXLDOPTS=
else
ifeq (Darwin,$(TARGET_SYS))
  export MACOSX_DEPLOYMENT_TARGET=10.4
  TARGET_STRIP+= -x
  TARGET_AR+= 2>/dev/null
  TARGET_XSHLDFLAGS= -dynamiclib -single_module -undefined dynamic_lookup -fPIC
  ifneq (,$(TARGET_DYNXLDOPTS))
    TARGET_DYNXLDOPTS=
    TARGET_XSHLDFLAGS+= -install_name $(PREFIX)/lib/$(TARGET_DYLIBNAME)
  endif
  ifeq (x64,$(TARGET_CCARCH))
    TARGET_XLDFLAGS+= -pagezero_size 10000 -image_base 100000000
    TARGET_XSHLDFLAGS+= -image_base 7fff04c4a000
  endif
else
  TARGET_XLDFLAGS+= -Wl,-E
  ifeq (Linux,$(TARGET_SYS))
    TARGET_XLIBS+= -ldl
  endif
  ifeq (GNU/kFreeBSD,$(TARGET_SYS))
    TARGET_XLIBS+= -ldl
  endif
endif
endif

ifneq (,$(CCDEBUG))
  TARGET_STRIP= @:
endif

##############################################################################
# Files and pathnames.
##############################################################################

prefix ?= /usr/local
libdir := $(prefix)/lib
includedir := $(prefix)/include

DASM_DIR= ../dynasm
DASM= $(HOST_LUA) $(DASM_DIR)/dynasm.lua
DASM_FLAGS=
DASM_DISTFLAGS= -LN
DASM_FLAGS_X86=
DASM_FLAGS_X64= -D X64
DASM_FLAGS_X64WIN= -D X64 -D X64WIN

BUILDVM_O= buildvm.o buildvm_asm.o buildvm_peobj.o buildvm_lib.o buildvm_fold.o
BUILDVM_T= buildvm
BUILDVM_X= ./$(BUILDVM_T)

HOST_O= $(BUILDVM_O)
HOST_T= $(BUILDVM_T)

LJVM_S= lj_vm.s
LJVM_O= lj_vm.o
LJVM_BOUT= $(LJVM_S)
LJVM_MODE= elfasm

LJLIB_O= lib_base.o lib_math.o lib_bit.o lib_string.o lib_table.o \
	 lib_io.o lib_os.o lib_package.o lib_debug.o lib_jit.o
LJLIB_C= $(LJLIB_O:.o=.c)

LJCORE_O= lj_gc.o lj_err.o lj_ctype.o lj_bc.o lj_obj.o \
	  lj_str.o lj_tab.o lj_func.o lj_udata.o lj_meta.o \
	  lj_state.o lj_dispatch.o lj_vmevent.o lj_api.o \
	  lj_lex.o lj_parse.o \
	  lj_ir.o lj_opt_mem.o lj_opt_fold.o lj_opt_narrow.o \
	  lj_opt_dce.o lj_opt_loop.o \
	  lj_mcode.o lj_snap.o lj_record.o lj_asm.o lj_trace.o lj_gdbjit.o \
	  lj_lib.o lj_alloc.o lib_aux.o \
	  $(LJLIB_O) lib_init.o

HEADERS := lua.h luaconf.h lualib.h lauxlib.h
HEADERS_INST := $(patsubst %,$(includedir)/%,$(HEADERS))

LJVMCORE_O= $(LJVM_O) $(LJCORE_O)
LJVMCORE_DYNO= $(LJVMCORE_O:.o=_dyn.o)

LIB_VMDEF= ../lib/vmdef.lua
LIB_VMDEFP= $(LIB_VMDEF)

LUAJIT_O= luajit.o
LUAJIT_A= libluajit.a
LUAJIT_SO= libluajit.so
LUAJIT_T= luajit

ALL_T= $(LUAJIT_T) $(LUAJIT_A) $(LUAJIT_SO) $(BUILDVM_T)
ALL_GEN= $(LJVM_S) lj_bcdef.h lj_ffdef.h lj_libdef.h lj_recdef.h \
	 $(LIB_VMDEFP) lj_folddef.h
ALL_DYNGEN= buildvm_*.h
WIN_RM= *.obj *.lib *.exp *.dll *.exe *.manifest *.pdb *.ilk
ALL_RM= $(ALL_T) $(ALL_GEN) *.o $(WIN_RM)

##############################################################################
# Build mode handling.
##############################################################################

# Mixed mode defaults.
TARGET_O= $(LUAJIT_A)
TARGET_T= $(LUAJIT_T) $(LUAJIT_SO)
TARGET_DEP= $(LIB_VMDEF) $(LUAJIT_SO)

ifeq (Windows,$(HOST_SYS))
  BUILDVM_T= buildvm.exe
  LIB_VMDEFP= $(subst /,\\,$(LIB_VMDEF))
endif
ifeq (Windows,$(TARGET_SYS))
  TARGET_DYNCC= $(STATIC_CC)
  LJVM_MODE= coffasm
  LUAJIT_SO= $(TARGET_DLLNAME)
  LUAJIT_T= luajit.exe
  ifneq ($(HOST_SYS),$(TARGET_SYS))
    HOST_XCFLAGS+= -malign-double
  endif
  # Mixed mode is not supported on Windows. And static mode doesn't work well.
  # C modules cannot be loaded, because they bind to lua51.dll.
  ifneq (static,$(BUILDMODE))
    BUILDMODE= dynamic
    TARGET_XCFLAGS+= -DLUA_BUILD_AS_DLL
  endif
endif
ifeq (Darwin,$(TARGET_SYS))

=== debian/changelog ===
crawl (2:0.9.1-maemo6) unstable; urgency=low
  
  * builder issue. version bumped.

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sat,  3 Sep 2011 09:57:30 +0200

crawl (2:0.9.1-maemo5) unstable; urgency=low
  
  * Tiles version without GLES, but GL (software)

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Thu,  2 Sep 2011 19:22:30 +0200

=== debian/control ===
--- 
+++ 
@@ -5,8 +5,10 @@
 Standards-Version: 3.9.2
 Build-Depends: debhelper (>= 7), libncursesw5-dev, bison, flex, liblua5.1-0-dev,
 	pkg-config, libsdl-image1.2-dev, libsdl1.2-dev, libsqlite3-dev,
-	libfreetype6-dev,  libpng12-dev, libsdl-gles1.2-dev,
-	libgles1-sgx-img-dev [arm armel], opengles-sgx-img-common-dev [arm armel], libgl1-mesa-dev [i386], libglu1-mesa-dev [i386]
+	libfreetype6-dev,  libpng12-dev, 
+#	libsdl-gles1.2-dev [arm armel], libgles1-sgx-img-dev [arm armel], opengles-sgx-img-common-dev [arm armel], libgl1-mesa-dev [i386], 
+	libglu1-mesa-dev, 
+	libgl1-mesa-swx11-dev [arm armel]	
 Homepage: http://crawl.develz.org/
 XSBC-Bugtracker: https://crawl.develz.org/mantis/

=== debian/rules ===
--- 
+++ 
@@ -36,7 +36,8 @@
 # The makefile is unorthodox, requiring all options to be specified on every invocation.
 ARGS_CONSOLE = prefix=$(PREFIX) CFOPTIMIZE=$(CFOPTIMIZE) WIZARD=y $(CROSS)
 ifneq (,$(findstring arm-linux,$(DEB_BUILD_GNU_TYPE)))
-ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GLES=y GAME=crawl-tiles \
+#GLES=y upstream is not working yet
+ARGS_TILES   = $(ARGS_CONSOLE) TILES=y GAME=crawl-tiles \
 	PROPORTIONAL_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSans.ttf \
 	MONOSPACED_FONT=/usr/share/fonts/truetype/ttf-dejavu/DejaVuSansMono.ttf
 else

## crawl 0.9.1-maemo7

=== debian/changelog ===
crawl (2:0.9.1-maemo7) unstable; urgency=low

  * explicitly dependencies

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sat,  3 Sep 2011 16:32:30 +0200

=== debian/control ===
--- 
+++ 
@@ -41,7 +41,8 @@
 
 Package: crawl-tiles
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
+Depends: libc6 (>= 2.5.0-1), libfreetype6 (>= 2.3.9-1osso2+0m5), libgcc1 (>= 1:4.2.1), libgl1-mesa-glx | libgl1, libglu1-mesa | libglu1 [i386], liblua5.1-0, libsdl-image1.2 (>= 1.2.4-5-recomp1), libsdl1.2 (>= 1.2.13-2maemo5+0m5), libsqlite3-0 (>= 3.6.14-1maemo1+0m5), libstdc++6 (>= 4.2.1-4maemo9+0m5), zlib1g (>= 1.2.3-9.osso9+0m5), crawl-common
+# ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
 Description: Dungeon Crawl, a roguelike game, tiles version
  Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
  Moria. Your objective is to travel deep into a subterranean cave complex and

## crawl 0.9.1-maemo8

=== debian/changelog ===
crawl (2:0.9.1-maemo8) unstable; urgency=low

  * explicitly dependencies part2

 -- Aapo Rantalainen <aapo.rantalainen@gmail.com>  Sat,  3 Sep 2011 17:28:30 +0200

=== debian/control ===
--- 
+++ 
@@ -41,7 +41,7 @@
 
 Package: crawl-tiles
 Architecture: any
-Depends: libc6 (>= 2.5.0-1), libfreetype6 (>= 2.3.9-1osso2+0m5), libgcc1 (>= 1:4.2.1), libgl1-mesa-glx | libgl1, libglu1-mesa | libglu1 [i386], liblua5.1-0, libsdl-image1.2 (>= 1.2.4-5-recomp1), libsdl1.2 (>= 1.2.13-2maemo5+0m5), libsqlite3-0 (>= 3.6.14-1maemo1+0m5), libstdc++6 (>= 4.2.1-4maemo9+0m5), zlib1g (>= 1.2.3-9.osso9+0m5), crawl-common
+Depends: libc6 (>= 2.5.0-1), libfreetype6 (>= 2.3.9-1osso2+0m5), libgcc1 (>= 1:4.2.1), libgl1-mesa-glx | libgl1, libglu1-mesa [i386] | libglu1 [i386], liblua5.1-0, libsdl-image1.2 (>= 1.2.4-5-recomp1), libsdl1.2 (>= 1.2.13-2maemo5+0m5), libsqlite3-0 (>= 3.6.14-1maemo1+0m5), libstdc++6 (>= 4.2.1-4maemo9+0m5), zlib1g (>= 1.2.3-9.osso9+0m5), crawl-common
 # ${shlibs:Depends}, ${misc:Depends}, crawl-common (= ${source:Version})
 Description: Dungeon Crawl, a roguelike game, tiles version
  Crawl is a fun game in the grand tradition of games like Rogue, Hack, and
